; ---------------------------------------------------------------------
; EBook					 STF
; ---------------------------------------------------------------------
; See_also       fouriereval fouriertrans 
; ---------------------------------------------------------------------
; Macro          STFfda02
; ---------------------------------------------------------------------
; Description    plots the estimated vola strings with linear interpolation
; ---------------------------------------------------------------------

proc()=STFfda02(data1, fdbasis,tau1m,tautrash)
  axesoff()
  volastring=createdisplay(1,1)

; delete data outside desired range

  range=fdbasis.range

  data1=paf(data1,(data1[,7]>=range[1]) && (data1[,7]<=range[2])) ;moneyness

  data1=sort(data1,2)
  tau=discrete(data1[,4])
  n=rows(tau.xr) ;anzahl der taus im tag

  ind1m=sum(tau.xr<tau1m) ; index 1m mat
  indtr=sum(tau.xr<tautrash) ; index for trash
 
  if (n>ind1m)
    if (tau.yr[ind1m+1]< 50) ; trashold for contract numbers
      trashnm=1
    else
      trashnm=0
    endif
  else
    trashnm=1
  endif   
    
  if(((! trashnm) && (indtr==0))&&(ind1m!=0)) ; interpolation is possible :-)

    datatau=paf(data1,data1[,4]==tau.xr[ind1m])

    tempx=datatau[,7] ;moneyness
    tempy=datatau[,8] ;vola

    point1d=tempx~tempy
    setmaskp(point1d,1,1,2)			

;      coefd=projectdata2fb(tempy,tempx,fdbasis) 

    y=tempy
    xvec=tempx
    period=fdbasis.range[2]-fdbasis.range[1]

;    evalxbasis=Fourierevalgd(xvec,fdbasis.nbasis,range) ; maybe add period
    nbasis=fdbasis.nbasis
    
    if(exist("period")==0) ; if no period period=range of xvec
      period=max(xvec)-min(xvec) ;zmaz 0.1
    endif

    error(nbasis<0|period<0,"Fouriereval: Negative argument!")

    n=rows(xvec)

    if (nbasis==2*floor(nbasis/2)) ; if nbasis even nbasis=nbasis+1
      nbasis=nbasis+1
    endif

    phi=0*matrix(n,nbasis)
    omegax=(2*pi/period)*xvec
    phi[,1]=sqrt(2)/2
    j=aseq(2,floor((nbasis-1)/2),2)
    argum=omegax.*(j/2)'
    phi[,j]=sin(argum)
    phi[,j+1]=cos(argum)
    phi = (phi / sqrt(period/2))  

    evalxbasis=phi
 
    coefd=inv(evalxbasis'*evalxbasis)*(evalxbasis'*y)
 

                  
    datatau=paf(data1,data1[,4]==tau.xr[ind1m+1])

    tempx=datatau[,7] ;moneyness
    tempy=datatau[,8] ;vola      

;      coefu=projectdata2fb(tempy,tempx,fdbasis)

    y=tempy
    xvec=tempx
    period=fdbasis.range[2]-fdbasis.range[1]

;    evalxbasis=Fourierevalgd(xvec,fdbasis.nbasis,range) ; maybe add period
    nbasis=fdbasis.nbasis
    
    if(exist("period")==0) ; if no period period=range of xvec
      period=max(xvec)-min(xvec) ;zmaz 0.1
    endif

    error(nbasis<0|period<0,"Fouriereval: Negative argument!")

    n=rows(xvec)

    if (nbasis==2*floor(nbasis/2)) ; if nbasis even nbasis=nbasis+1
      nbasis=nbasis+1
    endif

    phi=0*matrix(n,nbasis)
    omegax=(2*pi/period)*xvec
    phi[,1]=sqrt(2)/2
    j=aseq(2,floor((nbasis-1)/2),2)
    argum=omegax.*(j/2)'
    phi[,j]=sin(argum)
    phi[,j+1]=cos(argum)
    phi = (phi / sqrt(period/2))  

    evalxbasis=phi
 
    coefu=inv(evalxbasis'*evalxbasis)*(evalxbasis'*y)

; end projectdata2fd 


    g1=(tau.xr[ind1m+1] - tau1m)/(tau.xr[ind1m+1] - tau.xr[ind1m])
    g2=1-g1

    point1u=tempx~tempy
    setmaskp(point1u,2,1,2)
					      
    coef1m=g1.*coefd + g2.*coefu

    resol=aseq(range[1],100,(range[2]-range[1])/100)
     
    liner=#(1:rows(resol))'
;      yresol=Fourierevalgd(resol,fdbasis.nbasis)
    xvec=resol
    nbasis=fdbasis.nbasis
    period=max(xvec)-min(xvec)
    n=rows(xvec)

    if (nbasis==2*floor(nbasis/2)) ; if nbasis even nbasis=nbasis+1
      nbasis=nbasis+1
    endif

    phi=0*matrix(n,nbasis)
    omegax=(2*pi/period)*xvec
    phi[,1]=sqrt(2)/2
    j=aseq(2,floor((nbasis-1)/2),2)
    argum=omegax.*(j/2)'
    phi[,j]=sin(argum)
    phi[,j+1]=cos(argum)
    phi = (phi / sqrt(period/2))  
    yresol=phi
			
    four1d=resol~(coefd'*yresol')'
    four1u=resol~(coefu'*yresol')'
    four1m=resol~(coef1m'*yresol')'

    setmaskp(four1d,0,0,0)
    setmaskp(four1u,0,0,0)
    setmaskp(four1m,0,0,0)
			
    setmaskl(four1d,liner,1,6)
    setmaskl(four1u,liner,2,4)
    setmaskl(four1m,liner,0,1)

    axis1=graxes((0.9|1.1)~(0.15|0.3),"origin",0.9|0.15,"xticks",(0.95|1|1.05),"xtext",string("%3.2f",0.95)|"ATM"|string("%3.2f",1.15),"yticks",0.20|0.25)
    axis2=graxes((0.9|1.1)~(0.15|0.3),"origin",1.1|0.3,"xticks",(0.95|1|1.05),"xtext",string("%3.2f",0.95)|"ATM"|string("%3.2f",1.15),"yticks",0.20|0.25,"xtextpos",12,"ytextpos",3)


    show(volastring,1,1,four1d,four1u,four1m,point1u,point1d,axis1,axis2)
    text="IVs and IV strings"
    setgopt(volastring,1,1,"title",text);,"border",0)
    setgopt(volastring,1,1,"xlabel","test")
  else
  endif
  axeson()    

endp

fbname="fourier"
nbasis=9
range=0.9|1.1
fdbasis=list(fbname,nbasis,range)

library("stats")
data=read("stf/STFfda02.dat")
data=paf(data,data[,8]>0.15); delete outliers
STFfda02(data, fdbasis,30/360,0)

